package com.example.javacodegeeks.scala.rest

import org.scalatra._

//JSON related libraries
import org.json4s.{DefaultFormats, Formats}

//JSON handling support from Scalatra
import org.scalatra.json._

class MyScalatraServlet extends ScalarestwebappStack with JacksonJsonSupport {

  // Sets up automatic case class to JSON output serialization, required by
  // the JValueResult trait.
  protected implicit lazy val jsonFormats: Formats = DefaultFormats

  // Before every action runs, set the content type to be in JSON format
  before() {
  	println(" ====> Content-Type set to Json <===== ")
  	contentType = formats("json")
  }
  
  var customerMap = new CustomerMap() 

  get("/") {
    <html>
      <body>
        <h1>Hello, world!</h1>
        Say <a href="hello-scalate">hello to Scalate</a>.
      </body>
    </html>
  }

  get("/customers") {
	customerMap.map
  }

  get("/customer/:Id") {
  	var IdInt = Integer.parseInt(params("Id"))
        println("GET - Customer Id - arg. passed :: " + IdInt)
	customerMap.get(IdInt)
  }

  post("/customer/create") {
	var customer = parsedBody.extract[Customer]
	customerMap.add(customer)
  }

  delete("/customer/:Id") {
  	var IdInt = Integer.parseInt(params("Id"))
        println("DELETE - Customer Id - arg. passed :: " + IdInt)
	customerMap.remove(IdInt)
  	customerMap.map
  }
}

